package {
	
	import flash.events.Event;
	import flash.events.MouseEvent;
    import flash.display.Loader;
    import flash.display.BitmapData;
    import flash.display.Bitmap;
    import flash.net.URLRequest;
	
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.shadematerials.FlatShadeMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.objects.primitives.Plane;
    import org.papervision3d.materials.BitmapMaterial;
	
	[SWF(width=640, height=480, backgroundColor=0x808080, frameRate=30)]
	
	public class SimpleCube extends PV3DARApp {
		
		private var _plane:Plane;
		private var _cube:Cube;
        private var _loader:Loader;
        private var _imgList:Array;
        private var _3dObjects:Array;
        private var _nowObjects:Plane;
        private var _nowIndex:int = 0;
        private var _prevVisible:Boolean = false;
		
		public function SimpleCube() {
			addEventListener(Event.INIT, _onInit);
			// カメラ補正ファイルとパターン定義ファイルのファイル名を渡して初期化。
			init('Data/camera_para.dat', 'Data/flarlogo.pat');
            _imgList = [];
            _3dObjects = [];
		}
		
		private function _onInit(e:Event):void {
            // 一枚目の画像を読み込み
            _loader = new Loader();
            _loader.load(new URLRequest("webdb_logo1.png"));
            _loader.contentLoaderInfo.addEventListener(Event.COMPLETE, img01LoadCompleteHandler); 
       }

       private function img01LoadCompleteHandler(e:Event):void  {
            _imgList.push(Bitmap(_loader.content).bitmapData);
            // 二枚目の画像を尾y見込み
            _loader = new Loader();
            _loader.load(new URLRequest("webdb_logo2.png"));
            _loader.contentLoaderInfo.addEventListener(Event.COMPLETE, img02LoadCompleteHandler); 
       }

       private function img02LoadCompleteHandler(e:Event):void {
            _imgList.push(Bitmap(_loader.content).bitmapData);
            initAR();
       }


       private function initAR():void {

			// ライトの設定。手前、上のほう。
			var light:PointLight3D = new PointLight3D();
			light.x = 0;
			light.y = 1000;
			light.z = -1000;

			stage.addEventListener(MouseEvent.CLICK, _onClick);

            // 板にロゴを貼付けた物を2つ準備する
            for (var i:int = 0; i < _imgList.length; i++) {
                var img:BitmapData = _imgList[i];
                var bmat:BitmapMaterial = new BitmapMaterial(img, true);
                bmat.smooth = true;
                var p:Plane = new Plane(bmat , img.width/2, img.height/2);
                p.rotationX = 180;
                p.z = 50;
                _3dObjects.push(p);
            }

            // 最初に表示されるオブジェクト
            _markerNode.addChild(_3dObjects[0]);
            _nowObjects = _3dObjects[0];

            addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}

        private function enterFrameHandler(e:Event):void {
            
            // マーカーが認識されなくなったら、3Dオブジェクトを切り替える
            if (_markerNode.visible != _prevVisible && !_markerNode.visible) {
                if (_nowObjects) {
                    _markerNode.removeChild(_nowObjects);
                }
                _markerNode.addChild(_3dObjects[_nowIndex]);
                _nowObjects = _3dObjects[_nowIndex];

                _nowIndex++
                if (_nowIndex >= _3dObjects.length) _nowIndex = 0;
            }
            _prevVisible = _markerNode.visible;
        }
		
       private function _onClick(e:MouseEvent):void {
           mirror = !mirror;
       }
	}
}
